diff --git a/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java b/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java
index c512d7891..fa2426f45 100644
--- a/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/FootstepParticle.java
@@ -1,40 +1,42 @@
 package net.minecraft.client.entity.particle;
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.client.render.RenderEngine;
+import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 public class FootstepParticle extends Particle {
     private int life;
-    private int lifeTime;
-    private final RenderEngine renderEngine;
+    private final int lifeTime;
+    private final TextureManager textureManager;
 
-    public FootstepParticle(RenderEngine renderEngine, World world, double x, double y, double z) {
+    public FootstepParticle(TextureManager textureManager, World world, double x, double y, double z) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.life = 0;
-        this.renderEngine = renderEngine;
+        this.textureManager = textureManager;
         this.xd = this.yd = this.zd = 0.0D;
         this.lifeTime = 200;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float time = (life + partialTick) / lifeTime;
         time *= time;
         float a = 2.0F - time * 2.0F;
-        if(a > 1.0F) {
+        if (a > 1.0F) {
             a = 1.0F;
         }
         a *= 0.2F;
         GL11.glDisable(GL11.GL_LIGHTING);
         float s = 0.125F;
-        float x = (float)(this.x - xOff);
-        float y = (float)(this.y - yOff);
-        float z = (float)(this.z - zOff);
+        float x = (float) (this.x - xOff);
+        float y = (float) (this.y - yOff);
+        float z = (float) (this.z - zOff);
         float br = this.world.getLightBrightness(MathHelper.floor(this.x), MathHelper.floor(this.y), MathHelper.floor(this.z));
-        this.renderEngine.bindTexture(this.renderEngine.loadTexture("/assets/minecraft/textures/misc/footprint.png"));
+        this.textureManager.bindTexture(this.textureManager.loadTexture("/assets/minecraft/textures/misc/footprint.png"));
+
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         t.startDrawingQuads();
@@ -49,7 +51,7 @@ public class FootstepParticle extends Particle {
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.life++;
         if (this.life == this.lifeTime) {
             this.remove();
@@ -57,7 +59,7 @@ public class FootstepParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 3;
+    public int getParticleTexture() {
+        return ParticleEngine.ENTITY_PARTICLE_TEXTURE;
     }
 }
diff --git a/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java b/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java
index d343798e3..57681c0ad 100644
--- a/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/GoldenArrowParticle.java
@@ -5,7 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class GoldenArrowParticle extends Particle {
-    float oSize;
+    private final float oSize;
 
     public GoldenArrowParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         this(world, x, y, z, xa, ya, za, 1.0F);
@@ -20,17 +20,17 @@ public class GoldenArrowParticle extends Particle {
         this.yd += ya;
         this.zd += za;
         this.rCol = gCol = 0.8f;
-        this.bCol = (float)(Math.random() * 0.3D);
+        this.bCol = (float) (Math.random() * 0.3D);
         this.size *= 0.75F;
         this.size *= scale;
         this.oSize = this.size;
-        this.lifetime = (int)(8D / (Math.random() * 0.8D + 0.2D));
+        this.lifetime = (int) (8D / (Math.random() * 0.8D + 0.2D));
         this.lifetime *= (int) scale;
         this.noPhysics = false;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -39,11 +39,11 @@ public class GoldenArrowParticle extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java b/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java
index 161d5c441..69de17d2d 100644
--- a/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/HeartParticle.java
@@ -5,14 +5,13 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class HeartParticle extends Particle {
-    float oSize;
+    private final float oSize;
 
     public HeartParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         this(world, x, y, z, xa, ya, za, 2.0F);
     }
 
-    public HeartParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale)
-    {
+    public HeartParticle(World world, double x, double y, double z, double xa, double ya, double za, float scale) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
         this.xd *= 0.01D;
         this.yd *= 0.01D;
@@ -27,8 +26,7 @@ public class HeartParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2)
-    {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -37,11 +35,11 @@ public class HeartParticle extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
diff --git a/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java b/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java
index 602656adf..9df62f8f8 100644
--- a/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/LavaParticle.java
@@ -5,7 +5,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class LavaParticle extends Particle {
-    private float oSize;
+    private final float oSize;
 
     public LavaParticle(World world, double x, double y, double z) {
         super(world, x, y, z, 0.0D, 0.0D, 0.0D);
@@ -27,10 +27,10 @@ public class LavaParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = (this.age + partialTick) / this.lifetime;
         this.size = this.oSize * (1.0F - l * l);
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
index 509d371b5..ad3b9990b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/LeafParticle.java
@@ -5,6 +5,7 @@ import net.minecraft.client.render.LightmapHelper;
 // Referenced classes of package net.minecraft.src:
 //            EntityFX, Block, Tessellator, World
 
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -29,32 +30,31 @@ public class LeafParticle extends Particle {
         return !(block instanceof BaseLeavesBlock);
     }
 
-    public LeafParticle init(int x, int y, int z)
-    {
+    public LeafParticle init(int x, int y, int z) {
         Block block = Block.blocksList[this.world.getBlockId(x, y, z)];
         if (!(block instanceof BaseLeavesBlock)) this.remove();
         int col = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(world, x, y, z);
-        this.rCol *= (float)(col >> 16 & 0xff) / 255F;
-        this.gCol *= (float)(col >> 8 & 0xff) / 255F;
-        this.bCol *= (float)(col & 0xff) / 255F;
+        this.rCol *= (float) (col >> 16 & 0xff) / 255F;
+        this.gCol *= (float) (col >> 8 & 0xff) / 255F;
+        this.bCol *= (float) (col & 0xff) / 255F;
         return this;
     }
-    
+
     @Override
-	public void tick() {
+    public void tick() {
         float windDirection = this.world.worldType.getWindManager().getWindDirection(this.world, (float) this.x, (float) this.y, (float) this.z);
         float windIntensity = this.world.worldType.getWindManager().getWindIntensity(this.world, (float) this.x, (float) this.y, (float) this.z) * 0.01f;
 
         float dx = (float) (Math.cos(windDirection * Math.PI * 2) * windIntensity);
         float dz = (float) (Math.sin(windDirection * Math.PI * 2) * windIntensity);
-        
+
         this.xd += dx;
         this.zd += dz;
-        
+
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
-        if(this.age++ >= this.lifetime) {
+        if (this.age++ >= this.lifetime) {
             this.remove();
         }
         this.yd -= 0.04D * this.gravity;
@@ -66,25 +66,25 @@ public class LeafParticle extends Particle {
     }
 
     @Override
-	public int getParticleTexture() {
-        return 1;
+    public int getParticleTexture() {
+        return ParticleEngine.TERRAIN_TEXTURE;
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float u0 = (float) this.tex.getSubIconU(this.uo / 4F);
         float u2 = (float) this.tex.getSubIconU(0.25f);
         float v0 = (float) this.tex.getSubIconV(this.uo / 4F);
         float v2 = (float) this.tex.getSubIconV(0.25f);
         float r = 0.1F * this.size;
-        float x = (float)(this.xo + (this.x - this.xo) * partialTick - LeafParticle.xOff);
-        float y = (float)(this.yo + (this.y - this.yo) * partialTick - LeafParticle.yOff);
-        float z = (float)(this.zo + (this.z - this.zo) * partialTick - LeafParticle.zOff);
+        float x = (float) (this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float) (this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float) (this.zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	t.setLightmapCoord(getLightmapCoord(partialTick));
+        if (LightmapHelper.isLightmapEnabled()) {
+            t.setLightmapCoord(getLightmapCoord(partialTick));
         } else {
-        	br = getBrightness(partialTick);
+            br = getBrightness(partialTick);
         }
         t.setColorOpaque_F(br * this.rCol, br * this.gCol, br * this.bCol);
         t.addVertexWithUV(x - xa * r - xa2 * r, y - ya * r, z - za * r - za2 * r, u0, v2);
diff --git a/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
index 682ec57ea..42dfd9f8b 100644
--- a/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/NoteParticle.java
@@ -7,7 +7,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 
 public class NoteParticle extends Particle {
-    float oSize;
+    private final float oSize;
 
     public NoteParticle(World world, double x, double y, double z, double xa, double ya, double za) {
         this(world, x, y, z, xa, ya, za, 2.0F);
@@ -19,9 +19,9 @@ public class NoteParticle extends Particle {
         this.yd *= 0.01D;
         this.zd *= 0.01D;
         this.yd += 0.2D;
-        this.rCol = MathHelper.sin(((float)xa + 0.0F) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
-        this.gCol = MathHelper.sin(((float)xa + 1f/3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
-        this.bCol = MathHelper.sin(((float)xa + 2f/3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.rCol = MathHelper.sin(((float) xa + 0.0F) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.gCol = MathHelper.sin(((float) xa + 1f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
+        this.bCol = MathHelper.sin(((float) xa + 2f / 3) * MathHelper.PI * 2.0F) * 0.65F + 0.35F;
         this.size *= 0.75F;
         this.size *= scale;
         this.oSize = this.size;
@@ -31,7 +31,7 @@ public class NoteParticle extends Particle {
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -40,11 +40,11 @@ public class NoteParticle extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
@@ -64,5 +64,4 @@ public class NoteParticle extends Particle {
             this.zd *= 0.7D;
         }
     }
-
 }
diff --git a/src/main/java/net/minecraft/client/entity/particle/Particle.java b/src/main/java/net/minecraft/client/entity/particle/Particle.java
index bd7c57556..28bbe4f01 100644
--- a/src/main/java/net/minecraft/client/entity/particle/Particle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/Particle.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.entity.particle;
 
 import net.minecraft.client.render.LightmapHelper;
+import net.minecraft.client.render.ParticleEngine;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
@@ -8,6 +9,9 @@ import net.minecraft.core.util.helper.MathHelper;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.world.World;
 
+/**
+ * Displays a small, temporary texture in the world, used as a visual effect. Managed by {@link ParticleEngine}.
+ */
 public class Particle extends Entity {
     protected IconCoordinate tex;
     protected float uo;
@@ -19,14 +23,19 @@ public class Particle extends Entity {
     protected float rCol;
     protected float gCol;
     protected float bCol;
-    public static double xOff;
-    public static double yOff;
-    public static double zOff;
 
+    /**
+     * Creates a new Particle.
+     * @param world The world the particle will join.
+     * @param x The particle's initial X position.
+     * @param y The particle's initial Y position.
+     * @param z The particle's initial Z position.
+     * @param xa The particle's initial X velocity.
+     * @param ya The particle's initial Y velocity.
+     * @param za The particle's initial Z velocity.
+     */
     public Particle(World world, double x, double y, double z, double xa, double ya, double za) {
         super(world);
-        this.age = 0;
-        this.lifetime = 0;
         setSize(0.2F, 0.2F);
         this.heightOffset = this.bbHeight / 2.0F;
         setPos(x, y, z);
@@ -54,6 +63,10 @@ public class Particle extends Entity {
         return false;
     }
 
+    /**
+     * Sets the "power" of the particle, modifying its speed.
+     * @param power The particle's power.
+     */
     public Particle setPower(float power) {
         this.xd *= power;
         this.yd = (this.yd - 0.1D) * (double)power + 0.1D;
@@ -61,6 +74,10 @@ public class Particle extends Entity {
         return this;
     }
 
+    /**
+     * Sets the visual scale of the particle.
+     * @param scale The new scale of the particle.
+     */
     public Particle setScale(float scale) {
         setSize(0.2F * scale, 0.2F * scale);
         this.size *= scale;
@@ -95,16 +112,24 @@ public class Particle extends Entity {
         }
     }
 
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    /**
+     * Renders the particle in the world.
+     * @param t The tessellator to use to draw the particle.
+     * @param partialTick The time since the last tick.
+     * @param xOff The camera's X offset.
+     * @param yOff The camera's Y offset.
+     * @param zOff The camera's Z offset.
+     */
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         if (this.tex == null) return;
         float u0 = (float) this.tex.getIconUMin();
         float u2 = (float) this.tex.getSubIconU(1);
         float v0 = (float) this.tex.getIconVMin();
         float v2 = (float) this.tex.getSubIconV(1);
         float r = 0.1F * this.size;
-        float x = (float)(this.xo + (this.x - this.xo) * partialTick - Particle.xOff);
-        float y = (float)(this.yo + (this.y - this.yo) * partialTick - Particle.yOff);
-        float z = (float)(this.zo + (this.z - this.zo) * partialTick - Particle.zOff);
+        float x = (float)(this.xo + (this.x - this.xo) * partialTick - xOff);
+        float y = (float)(this.yo + (this.y - this.yo) * partialTick - yOff);
+        float z = (float)(this.zo + (this.z - this.zo) * partialTick - zOff);
         float br = 1.0f;
         if (LightmapHelper.isLightmapEnabled()) {
         	t.setLightmapCoord(getLightmapCoord(partialTick));
@@ -119,7 +144,7 @@ public class Particle extends Entity {
     }
 
     public int getParticleTexture() {
-        return 0;
+        return ParticleEngine.MISC_TEXTURE;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
index 957e4322e..39dda81c3 100644
--- a/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
+++ b/src/main/java/net/minecraft/client/entity/particle/ParticleDispatcher.java
@@ -12,21 +12,24 @@ import net.minecraft.core.util.helper.MathHelper;
 import java.util.ArrayList;
 import java.util.List;
 
-public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
-    private static final ParticleDispatcher instance = new ParticleDispatcher();
-    private static final ParticleLambda blank = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
-    public static ParticleDispatcher getInstance()
-    {
-        return instance;
+public final class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
+    private static final ParticleDispatcher INSTANCE = new ParticleDispatcher();
+    private static final ParticleLambda BLANK = (world, x, y, z, motionX, motionY, motionZ, data) -> null;
+
+    public static ParticleDispatcher getInstance() {
+        return INSTANCE;
     }
-    public List<String> getParticleIds(){
+
+    public List<String> getParticleIds() {
         return new ArrayList<>(dispatches.keySet());
     }
+
     @Override
     protected ParticleLambda getDefault() {
-        return blank;
+        return BLANK;
     }
-    private ParticleDispatcher(){
+
+    private ParticleDispatcher() {
         Minecraft mc = Minecraft.getMinecraft(this);
         addDispatch("bubble", (world, x, y, z, motionX, motionY, motionZ, data) -> new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, true));
         addDispatch("smoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX));
@@ -37,16 +40,16 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
         addDispatch("blueflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.BLUE));
         addDispatch("soulflame", (world, x, y, z, motionX, motionY, motionZ, data) -> new FlameParticle(world, x, y, z, motionX, motionY, motionX, FlameParticle.Type.SOUL));
         addDispatch("lava", (world, x, y, z, motionX, motionY, motionZ, data) -> new LavaParticle(world, x, y, z));
-        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new FootstepParticle(mc.renderEngine, world, x, y, z));
+        addDispatch("footstep", (world, x, y, z, motionX, motionY, motionZ, data) -> new FootstepParticle(mc.textureManager, world, x, y, z));
         addDispatch("splash", (world1, d, d1, d2, d3, d4, d5, data) -> new SplashParticle(world1, d, d1, d2, d3, d4, d5));
         addDispatch("largesmoke", (world, x, y, z, motionX, motionY, motionZ, data) -> new SmokeParticle(world, x, y, z, motionX, motionY, motionX, 2.5f));
         addDispatch("reddust", (world, x, y, z, motionX, motionY, motionZ, data) -> new RedstoneDustParticle(world, x, y, z, (float) motionX, (float) motionY, (float) motionZ, data));
         addDispatch("item", (world, x, y, z, motionX, motionY, motionZ, data) -> new BreakingItemParticle(world, x, y, z, Item.itemsList[MathHelper.clamp(data, 0, Item.itemsList.length - 1)]));
-        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new TerrainParticle(world, x, y, z,motionX,motionY,motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
+        addDispatch("block", (world, x, y, z, motionX, motionY, motionZ, data) -> new TerrainParticle(world, x, y, z, motionX, motionY, motionZ, Block.blocksList[BlockParticleHelper.decodeBlockID(data)], BlockParticleHelper.decodeBlockSide(data), BlockParticleHelper.decodeBlockMeta(data)).init((int) x, (int) y, (int) z));
         addDispatch("snowshovel", (world, x, y, z, motionX, motionY, motionZ, data) -> new SnowShovelParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("heart", (world, x, y, z, motionX, motionY, motionZ, data) -> new HeartParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("slimechunk", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            if (mc.gameSettings.slimeParticles.value){
+            if (mc.gameSettings.slimeParticles.value) {
                 return new SlimeChunkParticle(world, x, y, z, Items.SLIMEBALL);
             }
             return null;
@@ -57,9 +60,9 @@ public class ParticleDispatcher extends Dispatcher<String, ParticleLambda> {
         addDispatch("fireflyRed", (world, x, y, z, motionX, motionY, motionZ, data) -> new FireflyParticle(world, x, y, z, motionX, motionY, motionX, FireflyClusterMob.FireflyColor.RED.getId()));
         addDispatch("arrowtrail", (world, x, y, z, motionX, motionY, motionZ, data) -> new GoldenArrowParticle(world, x, y, z, motionX, motionY, motionX));
         addDispatch("fallingleaf", (world, x, y, z, motionX, motionY, motionZ, data) -> {
-            int id = world.getBlockId((int)x, (int)y, (int)z);
-            if (id != 0){
-                return new LeafParticle(world, x, y, z, motionX, motionY, motionX).init((int)x, (int)y, (int)z);
+            int id = world.getBlockId(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
+            if (id != 0) {
+                return new LeafParticle(world, x, y, z, motionX, motionY, motionX).init(MathHelper.floor(x), MathHelper.floor(y), MathHelper.floor(z));
             }
             return null;
         });
diff --git a/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
index c15436794..5fb1b84f6 100644
--- a/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
+++ b/src/main/java/net/minecraft/client/entity/particle/PortalParticle.java
@@ -5,13 +5,12 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.world.World;
 
 public class PortalParticle extends Particle {
-    private float oSize;
-    private double xStart;
-    private double yStart;
-    private double zStart;
+    private final float oSize;
+    private final double xStart;
+    private final double yStart;
+    private final double zStart;
 
-    public PortalParticle(World world, double x, double y, double z, double xd, double yd, double zd)
-    {
+    public PortalParticle(World world, double x, double y, double z, double xd, double yd, double zd) {
         super(world, x, y, z, xd, yd, zd);
         this.xd = xd;
         this.yd = yd;
@@ -21,26 +20,26 @@ public class PortalParticle extends Particle {
         this.zStart = this.z = z;
         float br = this.random.nextFloat() * 0.6F + 0.4F;
         this.oSize = this.size = random.nextFloat() * 0.2F + 0.5F;
-        this.rCol = this.gCol = this.bCol = 1.0F * br;
+        this.rCol = this.gCol = this.bCol = br;
         this.gCol *= 0.3F;
         this.rCol *= 0.9F;
-        this.lifetime = (int)(Math.random() * 10D) + 40;
+        this.lifetime = (int) (Math.random() * 10D) + 40;
         this.noPhysics = true;
-        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + (int)(Math.random() * 8D));
+        this.tex = TextureRegistry.getTexture("minecraft:particle/puff_" + (int) (Math.random() * 8D));
     }
 
     @Override
-    public void render(Tessellator t, float partialTick, float xa, float ya, float za, float xa2, float za2) {
+    public void render(Tessellator t, float partialTick, double xOff, double yOff, double zOff, float xa, float ya, float za, float xa2, float za2) {
         float s = (age + partialTick) / lifetime;
         s = 1.0F - s;
         s *= s;
         s = 1.0F - s;
         this.size = this.oSize * s;
-        super.render(t, partialTick, xa, ya, za, xa2, za2);
+        super.render(t, partialTick, xOff, yOff, zOff, xa, ya, za, xa2, za2);
     }
 
     @Override
-	public float getBrightness(float partialTick) {
+    public float getBrightness(float partialTick) {
         float br = super.getBrightness(partialTick);
         float pos = (float) this.age / (float) this.lifetime;
         pos *= pos;
@@ -49,7 +48,7 @@ public class PortalParticle extends Particle {
     }
 
     @Override
-	public void tick() {
+    public void tick() {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
